<?php

/* 
 *   This file is part of CLIGS v 2.0 - Cute Little Image Gallery System
 *   (c) Copyright 2005 John Leach <john@johnleach.co.uk> 
 *   http://johnleach.co.uk/documents/cligs
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

require_once 'metadata_cligs.php';
require_once 'metadata_gthumb.php';
require_once 'metadata_exif.php';

class Metadata
{
	var $title = 'NOTITLE';
	var $description;
	var $tags = array();
	# Text to put in the footer
	var $footer;
	# File to include as the footer
	var $footerfile;
	# Time in seconds since epoch
	var $time = 0;
	# relative path to an specified icon
	var $icon;
	var $root;

	function get_date($format = 'D jS F Y, g:i a')
	{
		return $this->time > 0 ? date($format, $this->time) : 'Unknown';
	}
}

class metadata_from_directory extends Metadata
{
	function metadata_from_directory ( $path )
	{
		$this->path = $path;
		if ( is_dir( $this->path ) )
			metadata_cligs_directory( $this );
	}
}

class metadata_from_file extends Metadata
{
	function metadata_from_file ( $path )
	{
		$this->path = $path;
		if ( is_file( $this->path ) ) {
			metadata_exif( $this );
			metadata_gthumb_image( $this );
		}
	}

}

?>
