<?php

function metadata_exif( &$metadata )
{
		$exif = @exif_read_data( $metadata->path );

		if ( !$exif ) {
			$metadata->group['exif'] = array();
			return;
		}

		foreach ( $exif as $key => $value ) {
			
			if ( !isset($value) )
				continue;

			if ( $key == 'PLACE' )
				$metadata->place = $value;
			
			elseif ( $key == 'NOTE' )
				$metadata->description = $value;

			elseif ( $key == 'FOOTER' )
				$metadata->footer = $value;

			elseif ( $key == 'FOOTERFILE' )
				$metadata->footerfile = $value;

			elseif ( $key == 'DateTime' ) {
				# FIXME: is this a universal format?
				# 2005:06:16 17:10:43
				if ( !ereg('([0-9]{4}):([0-9]{2}):([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})', $value, $r ) )
					continue;
				if ( count($r) < 6 )
					continue;
				$metadata->time = mktime($r[4], $r[5], $r[6], $r[2], $r[3], $r[1]);
			}

			elseif ( $key == 'KEYWORDS' )
				$metadata->tags = array_merge( $metadata->tags, split(',', $value) );
				
			$all_data[$key] = $value;
				
		}
		$metadata->group['exif'] = $all_data;
}
?>
