<?php

function metadata_gthumb_image( &$metadata )
{
		$metadata->title = basename( $metadata->path );

		$xml_filename = dirname($metadata->path) . '/.comments/' . basename($metadata->path) . '.xml';

		if ( !@is_file($xml_filename) )
			return FALSE;
		
		$zd = gzopen($xml_filename, "r");
		if ( !$zd ) {
			trigger_error( 'Error opening gthumb metadata', E_USER_WARNING );
			return FALSE;
		}
		$contents = gzread($zd, 10000);
		gzclose($zd);

		$xp = xml_parser_create();
		xml_parse_into_struct($xp, $contents, $vals, $index); # FIXME: succeeded?
		xml_parser_free($xp);

		$all_data = array();
		foreach ( $vals as $e ) {
			
			if ( !isset($e['value']) )
				continue;

			$key = $e['tag'];
			$value = $e['value'];

			if ( $key == 'PLACE' ) {
				$metadata->place = $value;
			}
			elseif ( $key == 'NOTE' ) {
				$metadata->description = $value;
			}
			elseif ( $key == 'FOOTER' ) {
				$metadata->footer = $value;
			}
			elseif ( $key == 'FOOTERFILE' ) {
				$metadata->footerfile = $value;
			}
			elseif ( $key == 'TIME' ) {
				if ( $value > 0 ) {
					$metadata->time = $value;
				}
			}
			elseif ( $key == 'KEYWORDS' ) {
				$metadata->tags = array_merge( $metadata->tags, split(',', $value) );
			}
				
			$all_data[$key] = $value;
				
		}
		$metadata->group['gthumb'] = $all_data;
}
?>
