<?

/* A set object populated from a filesystem path */
class set_filesystem extends Set
{
	# Filesystem path of this set
	var $path;
	# Filename FIXME
	var $filename;
	
	function set_filesystem( $path )
	{
		$this->path = $path;

		if ( is_file( $this->path ) ) {
			$parts = pathinfo( $this->path );
			$this->path = $parts['dirname'];
			$this->filename = $parts['basename'];
		}
		
		$this->meta = new metadata_from_directory( $this->path );
	}	
	
	function load()
	{
		$dh = @opendir( $this->path );
	
		if ( FALSE == $dh )
			trigger_error( 'Could not access that path.', E_USER_ERROR );

		while ( $file = readdir( $dh ) )
			$files[] = $file;
		
		closedir( $dh );
			
		asort($files);
		
		foreach ( $files as $file ) {
			$fn = $this->path . "/" . $file;
			
			// Ignore files beginning with dots	
			if ( eregi( "/\.+", $fn ) )
				continue;
			
			if ( is_dir( $fn ) ) {
				$subset = new set_filesystem( $fn );
				$this->add_subset( $subset );

			} elseif ( eregi( '^.*\.(jpg|jpeg|gif|png)$', $fn ) ) {
				$img = new image( $fn );
				$this->add_image( $img );
			
				if ( $file == $this->filename ) {
					$index = count( $this->images ) - 1;
				}
			} else {
				# $this->filelist[];
			}
		}

		
		$this->imglistcount = count( $this->images );

		if ( isset($index) ) {
			$this->thisimg =& $this->images[$index];
			$this->thisimg->index = $index;
			$this->previmg = FALSE;
			$this->nextimg = FALSE;
			if ( $index - 1 >= 0 )
				$this->previmg =& $this->images[$index - 1];
	
			if ( $index + 1 <= $this->imglistcount ) 
				$this->nextimg =& $this->images[$index + 1];
		}

		$this->parent = new Set( );
		$this->parent->path = dirname( $this->path );
		$this->parent->meta = new metadata_from_directory( dirname( $this->path ) );

		return TRUE;
	}
}

?>
